#---
# Excerpted from "Good Math: A Geeks Guide to the Beauty of Numbers, Logic, and Computation",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/mcmath for more book information.
#---
/* This code is based on the quicksort implementation
 * shown in the Wikipedia article on Prolog.
 */

/* quicksort(A, B) is true if B contains the same elements as A
 * but in sorted order.
 */
quicksort([], []).
quicksort([Head|Tail], Sorted) :-
  partition(Head, Tail, Smaller, Bigger),
  quicksort(Smaller, SmallerSorted),
  quicksort(Bigger, BiggerSorted),
  append(SmallerSorted, [Head | BiggerSorted], Sorted).

/* partition(A, B, C, D) is true if C and D are lists
 * where A = C + [B] + D
 */
partition(Pivot, [], [], []). /* (1) */
partition(Pivot, [Head | Tail], [Head | Smaller], Bigger) :- /* (2) */
   Head @=< Pivot,
   partition(Pivot, Tail, Smaller, Bigger).

partition(Pivot, [Head | Tail], Smaller, [Head | Bigger]) :- /* (3) */
   Head @> Pivot,
    partition(Pivot, Tail, Smaller, Bigger).

/* Append(A, B, C) is true if C = A + B */
append([], Result, Result).
append([Head | Tail], Other, [Head | Subappend]) :-
    append(Tail, Other, Subappend).

